
local LAM2 = LibStub("LibAddonMenu-2.0")

local colorYellow 		= "|cFFFF00" 	-- yellow 
local colorRed 			= "|cFF0000" 	-- Red
local colorDrkOrange 	= "|cFFA500"	-- Dark Orange

--[[
local tSounds = {
	["No Sound"]				= "None",
	["Killing Blow"]			= SOUNDS.DEATH_RECAP_KILLING_BLOW_SHOWN,
	["Attack"]					= SOUNDS.DEATH_RECAP_ATTACK_SHOWN,
	["Book Collection"]			= SOUNDS.BOOK_COLLECTION_COMPLETED,
	["Emporor Coronated"]		= SOUNDS.EMPEROR_CORONATED_EBONHEART,
	["Englightened State"]		= SOUNDS.ENLIGHTENED_STATE_GAINED,
	["Apply Charge"]			= SOUNDS.INVENTORY_ITEM_APPLY_CHARGE,
	["Level Up"]				= SOUNDS.LEVEL_UP,
	["Trial Completed"]			= SOUNDS.RAID_TRIAL_COMPLETED,
	["Trial New Best"]			= SOUNDS.RAID_TRIAL_NEW_BEST,
	["Skill Gained"]			= SOUNDS.SKILL_GAINED,
	["Skill Line Added"]		= SOUNDS.SKILL_LINE_ADDED,
	["Skill Line Level Up"]		= SOUNDS.SKILL_LINE_LEVELED_UP,
	["Boss Killed"]				= SOUNDS.SKILL_XP_BOSS_KILLED,
	["Dark Anchor"]				= SOUNDS.SKILL_XP_DARK_ANCHOR_CLOSED,
	["Dark Fissure"]			= SOUNDS.SKILL_XP_DARK_FISSURE_CLOSED,
	["Justice Gold"]			= SOUNDS.JUSTICE_GOLD_REMOVED,
	["Justice Now KOS"]			= SOUNDS.JUSTICE_NOW_KOS,
	["List Item Selected"]		= SOUNDS.HOR_LIST_ITEM_SELECTED,
	["Achievement Awarded"]		= SOUNDS.ACHIEVEMENT_AWARDED,
}
local tSoundNames = {}
do
	for k,v in pairs(tSounds) do
		table.insert(tSoundNames, v)
	end
end
--]]

local tSounds = {
	"None",
	SOUNDS.DEATH_RECAP_KILLING_BLOW_SHOWN,
	SOUNDS.DEATH_RECAP_ATTACK_SHOWN,
	SOUNDS.BOOK_COLLECTION_COMPLETED,
	SOUNDS.EMPEROR_CORONATED_EBONHEART,
	SOUNDS.ENLIGHTENED_STATE_GAINED,
	SOUNDS.INVENTORY_ITEM_APPLY_CHARGE,
	SOUNDS.LEVEL_UP,
	SOUNDS.RAID_TRIAL_COMPLETED,
	SOUNDS.RAID_TRIAL_NEW_BEST,
	SOUNDS.SKILL_GAINED,
	SOUNDS.SKILL_LINE_ADDED,
	SOUNDS.SKILL_LINE_LEVELED_UP,
	SOUNDS.SKILL_XP_BOSS_KILLED,
	SOUNDS.SKILL_XP_DARK_ANCHOR_CLOSED,
	SOUNDS.SKILL_XP_DARK_FISSURE_CLOSED,
	SOUNDS.JUSTICE_GOLD_REMOVED,
	SOUNDS.JUSTICE_NOW_KOS,
	SOUNDS.ACHIEVEMENT_AWARDED,
	SOUNDS.ABILITY_ULTIMATE_READY,
}
-------------------------------------------------------------------------------------------------
--  Settings Menu --
-------------------------------------------------------------------------------------------------
function TweakIt.CreateSettingsMenu()
	local panelData = {
		type = "panel",
		name = "TweakIt",
		displayName = "|cFF0000 Circonians |c00FFFF TweakIt",
		author = "Circonian",
		version = TweakIt.codeVersion,
		slashCommand = "/tweakIt",
		registerForRefresh = true,
		registerForDefaults = true,
	}
	local cntrlOptionsPanel = LAM2:RegisterAddonPanel("Circonians_TweakIt_Options", panelData)
	
	local optionsData = {
		[1] = {
			type = "submenu",
			name = "General",
			controls = {	
				[1] = {
					type = "checkbox",
					name = "Repair Equipped",
					tooltip = "Changes the Repair All button to Repair Equipped items when visiting a merchant.",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["REPAIR_EQUIPPED_KEYBIND_BUTTON"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["REPAIR_EQUIPPED_KEYBIND_BUTTON"] = bValue 
					TweakIt.InitStoreKeybindStripDescriptors()
					end
				},
				[2] = {
					type = "checkbox",
					name = "Hide Target Frame Always",
					tooltip = "Hides the target frame always (in and out of combat)..",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["HIDE_TARGET_FRAME_ALWAYS"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["HIDE_TARGET_FRAME_ALWAYS"] = bValue 
						if bValue then
							TweakIt.SavedVariables["HIDE_TARGET_FRAME"] = false
						end
						TweakIt.InitHideTargetFrame()
					end
				},
				[3] = {
					type = "checkbox",
					name = "Hide Target Frame Out Of Combat",
					tooltip = "Hides the target frame while out of combat. Hide target frame must be off.",
					default = false,
					disabled = function() return TweakIt.SavedVariables["HIDE_TARGET_FRAME_ALWAYS"] end,
					getFunc = function() return TweakIt.SavedVariables["HIDE_TARGET_FRAME"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["HIDE_TARGET_FRAME"] = bValue 
						TweakIt.InitHideTargetFrame()
					end
				},
				[4] = {
					type = "checkbox",
					name = "Mail: Default to COD",
					tooltip = "Automatically sets the mail send gold option to C.O.D. every time you open the mail send window. \nThis is to help prevent you from mistakenly sending someone all of your hard earned gold because you forgot to click C.O.D..",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["DEFAULT_TO_COD"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["DEFAULT_TO_COD"] = bValue 
					end
				},
				[5] = {
					type = "checkbox",
					name = "Show Hero Doll",
					tooltip = "Makes the hero doll (character window) visible when at the Bank, Guild Banks, Merchants, & the Guild Store.",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["HERO_DOLL_AT_BANK_MERCHANT"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["HERO_DOLL_AT_BANK_MERCHANT"] = bValue 
						TweakIt.InitHeroDoll()
					end
				},
				[6] = {
					type = "checkbox",
					name = "Hide Attribute Bars",
					tooltip = "Hides the attribute bars: Health, power, stamina, exc...",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["HIDE_ATTRIBUTE_BARS"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["HIDE_ATTRIBUTE_BARS"] = bValue 
						TweakIt.ShowHideResourceBars(bValue)
					end
				},
				[7] = {
					type = "checkbox",
					name = "LockPick Stop Sign",
					tooltip = "Displays a stop sign on screen to tell you when to let go of the mouse when picking locks.",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["LOCKPICK_STOP_SIGN"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["LOCKPICK_STOP_SIGN"] = bValue end
				},
			},
		},
		[2] = {
			type = "submenu",
			name = "Map Zoom",
			controls = {	
				[1] = {
					type = "dropdown",
					name = "Max World Map Zoom",
					tooltip = "Adjusts the maximum zoom amount for the world map.\n0 Represents the games normal max zoom magnification amount.",
					choices = {0, 5, 10, 15},
					--sort = "name-up",
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_MAX_ZOOM"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_MAX_ZOOM"] = iValue  
						TweakIt.InitMaxWorldMapZoom(MAP_CONTENT_NONE)
					end,
				},
				[2] = {
					type = "slider",
					name = "Default Zoom",
					tooltip = "This setting will be used for any map that doesn't fall under one of the categories below.",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_DEFAULT_ZOOM"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_DEFAULT_ZOOM"] = iValue  
					end,
				},
				[3] = {
					type = "slider",
					name = "Fast Travel Wayshrine Zoom",
					tooltip = "Sets the default zoom for the Fast Travel Wayshrine map.",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_ZOOM_FAST_TRAVEL"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_ZOOM_FAST_TRAVEL"] = iValue  
					end,
				},
				[4] = {
					type = "slider",
					name = "Fast Travel Keep Zoom",
					tooltip = "Sets the default zoom for the Fast Travel Keep Transit Shrine map.",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_ZOOM_FAST_TRAVEL_KEEP"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_ZOOM_FAST_TRAVEL_KEEP"] = iValue  
					end,
				},
				[5] = {
					type = "slider",
					name = "World Map Default Zoom",
					tooltip = "Sets the default zoom for the world map  (Tamriel).",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_ZOOM_WORLD"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_ZOOM_WORLD"] = iValue  
					end,
				},
				[6] = {
					type = "slider",
					name = "Zone Map Default Zoom",
					tooltip = "Sets the default zoom for zone maps.",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_ZOOM_ZONE"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_ZOOM_ZONE"] = iValue  
					end,
				},
				[7] = {
					type = "slider",
					name = "SubZone Map Default Zoom",
					tooltip = "Sets the default zoom for the sub zone maps (like towns).",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_ZOOM_SUBZONE"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_ZOOM_SUBZONE"] = iValue  
					end,
				},
				[8] = {
					type = "slider",
					name = "Dungeon Map Default Zoom",
					tooltip = "Sets the default zoom for dungeon maps.",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_ZOOM_DUNGEON"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_ZOOM_DUNGEON"] = iValue  
					end,
				},
				[9] = {
					type = "slider",
					name = "AvA Map Default Zoom",
					tooltip = "Sets the default zoom for the ava maps.",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_ZOOM_AVA"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_ZOOM_AVA"] = iValue  
					end,
				},
				[10] = {
					type = "slider",
					name = "AVA Respawn Zoom",
					tooltip = "Sets the default zoom for the AVA Respawn Map.",
					min = 1,
					max = 9,
					step = 1,
					default = 5,
					getFunc = function() return TweakIt.SavedVariables["WORLD_MAP_ZOOM_AVA_RESPAWN"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WORLD_MAP_ZOOM_AVA_RESPAWN"] = iValue  
					end,
				},
			},
		},
		[3] = {
			type = "submenu",
			name = "Automatic Waypoint Removal",
			controls = {	
				[1] = {
					type = "checkbox",
					name = "Auto-Remove Waypoints",
					tooltip = "Automatically removes waypoints once you reach them.",
					width 	= "half",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["AUTO_REMOVE_WAYPOINT"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["AUTO_REMOVE_WAYPOINT"] = bValue 
						if bValue then 
							TweakIt.InitWaypoint()
						else
							EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."RemoveWaypoint") 
						end
					end
				},
				[2] = {
					type = "checkbox",
					name = "Waypoints Messages",
					tooltip = "Displays a center screen announcement when you set & reach your waypoints.",
					width 	= "half",
					disabled = function() return not TweakIt.SavedVariables["AUTO_REMOVE_WAYPOINT"] end,
					default = false,
					getFunc = function() return TweakIt.SavedVariables["AUTO_REMOVE_WAYPOINT_MESSAGES"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["AUTO_REMOVE_WAYPOINT_MESSAGES"] = bValue 
						if not bValue then EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."RemoveWaypoint") end
					end
				},
				[3] = {
					type = "slider",
					name = "Waypoint Distance",
					tooltip = "Allows you to adjust the distance you must be from a waypoint before it is automatically removed.\n "..colorDrkOrange.."A larger number means the waypoint gets removed sooner, a smaller number means you must be closer for the waypoint to be removed.",
					min = 1,
					max = 5,
					step = 1,
					default = 2,
					getFunc = function() return TweakIt.SavedVariables["WAYPOINT_DELTA_SCALE"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["WAYPOINT_DELTA_SCALE"] = iValue end,
				},
			},
		},
		[4] = {
			type = "submenu",
			name = "Recall Cooldown Timer",
			controls = {	
			[1] = {
				type = "checkbox",
				name = "Recall Cooldown Timer",
				tooltip = "When you recall this feature will display a window on the screen with a recall cooldown timer & recall cost.",
				width 	= "half",
				default = false,
				getFunc = function() return TweakIt.SavedVariables["RECALL_COOLDOWN_TIMER"] end,
				setFunc = function(bValue) TweakIt.SavedVariables["RECALL_COOLDOWN_TIMER"] = bValue 
					if bValue then
						-- Check to see if we need to start a timer
						TweakIt.CheckRecallCooldown()
					else
						-- Unregister any Update timers & hide it.
						EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."RecallCooldownTime")
						EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."RecallCooldownGold")
						TweakItRecallCooldown:SetHidden(true)
						TweakItRecallCooldown:SetAlpha(0)
						TWEAKIT_RECALL_WINDOW_VISIBILITY:UpdateValue(false, false)
					end
				end
			},
			[2] = {
				type = "checkbox",
				name = "Make recall cooldown window visible.",
				tooltip = "Makes the recall cooldown window permanently visible and can be used to make it visible for positioning it on the screen. Recall Cooldown Timer must be turned ON.",
				width 	= "half",
				disabled = function() return not TweakIt.SavedVariables["RECALL_COOLDOWN_TIMER"] end,
				default = false,
				getFunc = function() return TweakIt.SavedVariables["RECALL_COOLDOWN_WINDOW"] end,
				setFunc = function(bValue) TweakIt.SavedVariables["RECALL_COOLDOWN_WINDOW"] = bValue 
					if bValue then
						TweakItRecallCooldown:SetHidden(false)
						TweakItRecallCooldown:SetAlpha(1)
					elseif GetRecallCooldown() == 0 then
						-- hide it. If there is a cooldown timer it will hide itself when it finishes.
						TweakItRecallCooldown:SetHidden(true)
						TweakItRecallCooldown:SetAlpha(0)
					end
				end,
				reference = "TWEAKIT_RECALL_WINDOW_VISIBILITY",
			},
			},
		},
		
		[5] = {
			type = "submenu",
			name = "Current Weapon",
			controls = {	
			[1] = {
				type = "checkbox",
				name = "Show Current Weapon",
				tooltip = colorYellow.."(Account Wide Setting)|r".." Displays an icon window showing which weapon you currently have equipped. \n"..colorYellow.."Double click on weapons window to toggle \"Current Weapon\" text. \n"..colorDrkOrange.."Hold mouse over weapons window & scroll mouse wheel to resize icons.",
				width = "half",
				default = false,
				getFunc = function() return TweakIt.SavedVariables["CURRENT_WEAPON_WINDOW"] end,
				setFunc = function(bValue) TweakIt.SavedVariables["CURRENT_WEAPON_WINDOW"] = bValue 
					if bValue and not TweakIt.SavedVariablesChar["CURRENT_WEAPON_WINDOW_CHAR_OVERRIDE"] then 
						TweakIt.UpdateCurrentWeapons() 
						TweakIt.HideWeaponWin(false)
					else
						TweakIt.HideWeaponWin(true)
					end
				end
			},
			[2] = {
				type = "checkbox",
				name = "Hide Current Weapon",
				tooltip = colorYellow.."(Character Specific Override)|r".." Used if you don't want to show current weapons on this specific character. Does not effect the account wide setting.",
				width = "half",
				default = false,
				getFunc = function() return TweakIt.SavedVariablesChar["CURRENT_WEAPON_WINDOW_CHAR_OVERRIDE"] end,
				setFunc = function(bValue) TweakIt.SavedVariablesChar["CURRENT_WEAPON_WINDOW_CHAR_OVERRIDE"] = bValue 
					if not bValue and TweakIt.SavedVariables["CURRENT_WEAPON_WINDOW"] then
						TweakIt.UpdateCurrentWeapons() 
						TweakIt.HideWeaponWin(false)
					else
						TweakIt.HideWeaponWin(true)
					end
				end
			},
			},
		},
		
		[6] = {
			type = "submenu",
			name = "Death Blow",
			controls = {	
			[1] = {
				type = "checkbox",
				name = "Death Blow Message",
				tooltip = "Displays an on screen message when you score the killing blow.\n"..colorYellow.."Toggle this setting OFF & back ON to force window to appear for 7 seconds (allows you to position it on screen during this time).",
				width = "half",
				default = false,
				getFunc = function() return TweakIt.SavedVariables["CURRENT_KILL_WINDOW"] end,
				setFunc = function(bValue) TweakIt.SavedVariables["CURRENT_KILL_WINDOW"] = bValue 
					if bValue then
						TweakItKillWindow:SetHidden(false)
						TweakItKillWindow:SetAlpha(1)
						TweakItKillWindow.timeline:PlayFromStart()
					end
				end
			},
			[2] = {
				type = "dropdown",
				name = "Death Blow Sound",
				tooltip = "Plays a sound when you score the killing blow.",
				width = "half",
				choices = tSounds,
				sort = "name-up",
				getFunc = function() return TweakIt.SavedVariables["KILL_SOUND"] end,
				setFunc = function(sValue) TweakIt.SavedVariables["KILL_SOUND"] = sValue
				end,
			},
			},
		},
		
		[7] = {
			type = "submenu",
			name = "Crafting",
			controls = {	
			[1] = {
				type = "checkbox",
				name = "Default Improvment to 100%",
				tooltip = "Automatically adds the number of boosters required to get a 100% success chance when adding an item to the improvement slot (if you have enough boosters).",
				default = false,
				getFunc = function() return TweakIt.SavedVariables["IMPROVE_AUTO_MAX_BOOSTERS"] end,
				setFunc = function(bValue) TweakIt.SavedVariables["IMPROVE_AUTO_MAX_BOOSTERS"] = bValue 
				end
			},
			[2] = {
				type = "checkbox",
				name = "Skip Dialog at 100% success chance.",
				tooltip = "Skip the confirmation dialog when the success chance is 100%.",
				default = false,
				getFunc = function() return TweakIt.SavedVariables["IMPROVE_100SUCCESS_SKIP_DIALOG"] end,
				setFunc = function(bValue) TweakIt.SavedVariables["IMPROVE_100SUCCESS_SKIP_DIALOG"] = bValue 
				end
			},
			},
		},
		
		[8] = {
			type = "submenu",
			name = "Campaign Que",
			controls = {	
				[1] = {
					type = "checkbox",
					name = "Show Campaign Que Window",
					tooltip = "Shows a window with your current campaign state & position in the que.",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["CAMPAIGN_QUE_WINDOW"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["CAMPAIGN_QUE_WINDOW"] = bValue
						if bValue then
							TweakIt.UpdateCampaignWindow(nil, nil, nil, nil)
						else
							EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."CampaignTime")
							TweakItCampaignQue:SetHidden(true)
						end
					end,
				},
				[2] = {
					type = "checkbox",
					name = "Auto-Join Campaign",
					tooltip = "Will automatically join the campaign queue for you if you have not responded by either joining the campaign or leaving the queue. You can adjust when it will automatically join in the setting below.",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["CAMPAIGN_QUE_AUTOJOIN"] end,
					setFunc = function(bValue) TweakIt.SavedVariables["CAMPAIGN_QUE_AUTOJOIN"] = bValue
					end,
				},
				[3] = {
					type = "slider",
					name = "Auto-Join Campaign Time",
					tooltip = "This setting will determine when the auto-join feature will run to automatically join the campaign for you. \"Auto-Join Campaign\" must be turned ON.",
					min = 3,
					max = 60,
					step = 1,
					default = 5,
					disabled = function() return not TweakIt.SavedVariables["CAMPAIGN_QUE_AUTOJOIN"] end,
					getFunc = function() return TweakIt.SavedVariables["CAMPAIGN_QUE_AUTOJOIN_TIME"] end,
					setFunc = function(iValue) TweakIt.SavedVariables["CAMPAIGN_QUE_AUTOJOIN_TIME"] = iValue  
					end,
				},
			},
		},
	--=================================================--
	-- Removed, The game now has this feature built in --
	-- Well...it did on the PTS...they removed it. It used to show both bank & backpack space --
	-- while in the bank, not anymore.
	--=================================================--
---[[
		[9] = {
			type = "submenu",
			name = "Extended Info Bar",
			controls = {	
				[1] = {
					type = "description",
					text = "Extended Info Bar: (bottom of backpack & other windows) \nAlways Displays: backpack space, bank space, alliance points, carried gold, & banked gold. Fence transaction info will be shown only when at a fence.",
				},
				[2] = {
					type = "checkbox",
					name = "Extended Inventory Info Bar",
					tooltip = "THIS WILL RELOAD THE UI. Show/Hide the extended inventory information bar.",
					default = false,
					getFunc = function() return not TweakIt.SavedVariables["HIDE_EXTENDED_INV_INFO"] end,
					setFunc = function(bValue) 
						local newVal = not bValue
						TweakIt.SavedVariables["HIDE_EXTENDED_INV_INFO"] = newVal
						--ExtendedInfoBar_ToggleExtendedInfo(newVal)
						ReloadUI("ingame")
					end
				},
			},
		},
--]]		
		[10] = {
			type = "submenu",
			name = "Compass",
			controls = {	
				[1] = {
					type = "description",
					text = "These are account wide settings.",
				},
				[2] = {
					type = "checkbox",
					name = "Change Compass Height",
					tooltip = "Turn ON/OFF the resizing of the compass height.",
					default = false,
					getFunc = function() return TweakIt.SavedVariables["RESIZE_COMPASS"] end,
					setFunc = function(bValue) 
						TweakIt.SavedVariables["RESIZE_COMPASS"] = bValue
					end
				},
				[3] = {
					type = "slider",
					name = "Compass Height",
					tooltip = "This setting will adjust the height of the compass.",
					min = 10,
					max = 60,
					step = 5,
					default = 40,
					disabled = function() return not TweakIt.SavedVariables["RESIZE_COMPASS"] end,
					getFunc = function() return TweakIt.SavedVariables["RESIZE_COMPASS_SIZE"] end,
					setFunc = function(iValue) 
						TweakIt.SavedVariables["RESIZE_COMPASS_SIZE"] = iValue
						TweakIt.ChangeCompassHeight(iValue)
					end,
				},
			},
		},
	}
	LAM2:RegisterOptionControls("Circonians_TweakIt_Options", optionsData)
end