
-- Holds last index for keybindings search box so we can continue the search
-- to find the next text match
local lastIndex = 1
local colorDrkOrange 	= "|cFFA500"	-- Dark Orange
--local FRAGMENT_TWEAKIT_WEAPONS


function TweakIt.ChangeCompassHeight(height)
	ZO_CompassFrame:SetHeight(height)
	ZO_CompassFrameRight:SetHeight(height)
	ZO_CompassFrameLeft:SetHeight(height)
end



local function CheckStress()
	if GetSettingChamberStress() > 0 and not IsChamberSolved(LOCK_PICK.settingChamberIndex) then 
		-- Sounds play to slow to be useful, its deceiving
		--PlaySound(SOUNDS.DEATH_RECAP_ATTACK_SHOWN)
		TweakIt.stopSign:SetHidden(false)
	else
		TweakIt.stopSign:SetHidden(true) 
	end
end

local function OnStartPicking()
	if not TweakIt.SavedVariables["LOCKPICK_STOP_SIGN"] then return end
	
	EVENT_MANAGER:RegisterForUpdate("LockPickIt", 10, CheckStress)
	return false
end
ZO_PreHook("ZO_Lockpick_OnMouseDown", OnStartPicking)

local function OnStopPicking()
	EVENT_MANAGER:UnregisterForUpdate("LockPickIt")
	TweakIt.stopSign:SetHidden(true) 
	return false
end
ZO_PreHook("ZO_Lockpick_OnMouseUp", OnStopPicking)



function TweakIt.ShowHideResourceBars(hide)
	PLAYER_ATTRIBUTE_BARS_FRAGMENT:SetHiddenForReason("TweakIt_Disabled", hide)
end


local tCampaignStates = {
	[CAMPAIGN_QUEUE_REQUEST_STATE_CONFIRMING]		= "Confirming",
	[CAMPAIGN_QUEUE_REQUEST_STATE_FINISHED]			= "Finished",
	[CAMPAIGN_QUEUE_REQUEST_STATE_PENDING_ACCEPT]	= "Pending Acceptance",
	[CAMPAIGN_QUEUE_REQUEST_STATE_PENDING_JOIN]		= "Pending Join",
	[CAMPAIGN_QUEUE_REQUEST_STATE_PENDING_LEAVE]	= "Pending Leave",
	[CAMPAIGN_QUEUE_REQUEST_STATE_WAITING]			= "Waiting in que.",
}

--[[
local function DoSearch(_cEditBox, _bNextSearch)
	if not _cEditBox then return end
	
	local label = _cEditBox:GetParent():GetNamedChild("Label")
	label:SetHidden(true)
	
	_cEditBox:LoseFocus()
	
	local sSearchText = string.lower(_cEditBox:GetText())
	if not sSearchText or sSearchText == "" then return end
	local yOffsetPadding = 15
	
	local listData = ZO_KeybindingsList.data
	
	if not _bNextSearch then
		lastIndex = 1
	end
	
	for i = lastIndex+1, #listData do
		local layerName = string.lower(listData[i].data.layerName)
		local categoryName = string.lower(listData[i].data.categoryName)
		local localizedActionName = string.lower(listData[i].data.localizedActionName)
		
		if layerName and layerName:find(sSearchText) then
			ZO_KeybindingsListScrollBar:SetValue(listData[i].top-yOffsetPadding)
			lastIndex = i
			return
		elseif categoryName and categoryName:find(sSearchText) then
			ZO_KeybindingsListScrollBar:SetValue(listData[i].top-yOffsetPadding)
			lastIndex = i
			return
		elseif localizedActionName and localizedActionName:find(sSearchText) then
			ZO_KeybindingsListScrollBar:SetValue(listData[i].top-yOffsetPadding)
			lastIndex = i
			return
		end
	end
	local label = _cEditBox:GetParent():GetNamedChild("Label")
	label:SetHidden(false)
end

local function FindNext(_cNextBtn)
	local editBox = _cNextBtn:GetParent():GetNamedChild("EditBox")
	DoSearch(editBox, true)
end

function TweakIt.SetUpKeybindingsSearch()
	local cSearchBox = WINDOW_MANAGER:CreateControl(ZO_Keybindings:GetName() .. "TweakItSearchBox", ZO_Keybindings, CT_EDITBOX)
	cSearchBox:ClearAnchors()
	cSearchBox:SetAnchor(TOPLEFT, ZO_Keybindings, TOPLEFT, 25, 25)
	cSearchBox:SetDimensions(200, 25)
	cSearchBox:SetMouseEnabled(true)
	
	--local cNextBtn = WINDOW_MANAGER:CreateControlFromVirtual(cSearchBox:GetName().."NextBtn", cSearchBox, "ZO_DefaultTextButton")
	local cNextBtn = WINDOW_MANAGER:CreateControlFromVirtual(cSearchBox:GetName().."NextBtn", cSearchBox,  "ZO_BladeHeader")
	cNextBtn:ClearAnchors()
	cNextBtn:SetAnchor(LEFT, cSearchBox, RIGHT, 25, 0)
	cNextBtn:SetDimensions(60, 30)
	cNextBtn:SetText("Next")
	cNextBtn:SetHandler("OnClicked", FindNext)
	cNextBtn:SetClickSound("Click")
	
	cNextBtn.data = { tooltipText = "Find the next text match." }
    cNextBtn:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    cNextBtn:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
	
	cSearchBox.bg = WINDOW_MANAGER:CreateControlFromVirtual(cSearchBox:GetName().."background", cSearchBox, "ZO_EditBackdrop")
	cSearchBox.bg:ClearAnchors()
	cSearchBox.bg:SetAnchorFill()
	cSearchBox.bg:SetDrawTier(1)
	
	cSearchBox.editbox = WINDOW_MANAGER:CreateControlFromVirtual(cSearchBox:GetName().."EditBox", cSearchBox, "ZO_DefaultEditForBackdrop")
	cSearchBox.editbox:ClearAnchors()
	cSearchBox.editbox:SetAnchorFill()
	cSearchBox.editbox:SetText("Enter Search Text")
	cSearchBox.editbox:SetHandler("OnEnter", DoSearch)
	cSearchBox.editbox:SetHandler("OnMouseDoubleClick", function() cSearchBox.editbox:Clear() end)
	cSearchBox.editbox.data = { tooltipText = "Enter text to search for. \nDouble click to clear text." }
    cSearchBox.editbox:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    cSearchBox.editbox:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
	
	cSearchBox.label = WINDOW_MANAGER:CreateControl(cSearchBox:GetName() .. "Label", cSearchBox, CT_LABEL)
	cSearchBox.label:SetDimensions(200, 30)
	cSearchBox.label:ClearAnchors()
	cSearchBox.label:SetAnchor(TOPLEFT, cSearchBox, BOTTOMLEFT, 0, 5)
	cSearchBox.label:SetText("Not Found")
	cSearchBox.label:SetFont("ZoFontWinH4")
	cSearchBox.label:SetColor(1, 0, 0)
	cSearchBox.label:SetHidden(true)
end
--]]


-- Turns ON/OFF the feature to hide the target frame based on the saved var
function TweakIt.InitHideTargetFrame()
	if TweakIt.SavedVariables["HIDE_TARGET_FRAME_ALWAYS"] then
		UNIT_FRAMES:SetFrameHiddenForReason("reticleover", "TweakItFrameOff", true)
	else
		UNIT_FRAMES:SetFrameHiddenForReason("reticleover", "TweakItFrameOff", false)
	end
	
	if TweakIt.SavedVariables["HIDE_TARGET_FRAME"] then
		ZO_UnitFrames:RegisterForEvent(EVENT_PLAYER_COMBAT_STATE, function(eventCode, bInCombat) 
			UNIT_FRAMES:SetFrameHiddenForReason("reticleover", "combatstate", not bInCombat)
			ZO_UnitFrames_UpdateWindow("reticleover", true)
			end)
		UNIT_FRAMES:SetFrameHiddenForReason("reticleover", "combatstate", true)
	else
		ZO_UnitFrames:UnregisterForEvent(EVENT_PLAYER_COMBAT_STATE)
		UNIT_FRAMES:SetFrameHiddenForReason("reticleover", "combatstate", false)
	end
end

-- Shows hero doll at bank
function TweakIt.InitHeroDoll()
	if TweakIt.SavedVariables["HERO_DOLL_AT_BANK_MERCHANT"] then
		SCENE_MANAGER.scenes.bank:AddFragment(CHARACTER_WINDOW_FRAGMENT)
		SCENE_MANAGER.scenes.bank:AddFragment(THIN_LEFT_PANEL_BG_FRAGMENT)
		SCENE_MANAGER.scenes.store:AddFragment(CHARACTER_WINDOW_FRAGMENT)
		SCENE_MANAGER.scenes.store:AddFragment(THIN_LEFT_PANEL_BG_FRAGMENT)
		SCENE_MANAGER.scenes.guildBank:AddFragment(CHARACTER_WINDOW_FRAGMENT)
		SCENE_MANAGER.scenes.guildBank:AddFragment(THIN_LEFT_PANEL_BG_FRAGMENT)
		SCENE_MANAGER.scenes.tradinghouse:AddFragment(CHARACTER_WINDOW_FRAGMENT)
		SCENE_MANAGER.scenes.tradinghouse:AddFragment(THIN_LEFT_PANEL_BG_FRAGMENT)
	else
		SCENE_MANAGER.scenes.bank:RemoveFragment(CHARACTER_WINDOW_FRAGMENT)
		SCENE_MANAGER.scenes.bank:RemoveFragment(THIN_LEFT_PANEL_BG_FRAGMENT)
		SCENE_MANAGER.scenes.store:RemoveFragment(CHARACTER_WINDOW_FRAGMENT)
		SCENE_MANAGER.scenes.store:RemoveFragment(THIN_LEFT_PANEL_BG_FRAGMENT)
		SCENE_MANAGER.scenes.guildBank:RemoveFragment(CHARACTER_WINDOW_FRAGMENT)
		SCENE_MANAGER.scenes.guildBank:RemoveFragment(THIN_LEFT_PANEL_BG_FRAGMENT)
		SCENE_MANAGER.scenes.tradinghouse:RemoveFragment(CHARACTER_WINDOW_FRAGMENT)
		SCENE_MANAGER.scenes.tradinghouse:RemoveFragment(THIN_LEFT_PANEL_BG_FRAGMENT)
	end
end

-- Adjust maximum world map zoom
function TweakIt.InitMaxWorldMapZoom()
	local iMaxZoom = TweakIt.SavedVariables["WORLD_MAP_MAX_ZOOM"]
	
	if iMaxZoom == 0 then
		ZO_WorldMap_ClearCustomZoomLevels()
	else
		ZO_WorldMap_SetCustomZoomLevels(1, iMaxZoom)
	end   
end
 
local function GetSettingForMapType()
	local mapMode = ZO_WorldMap_GetMode() 

	if mapMode == MAP_MODE_FAST_TRAVEL then
		return TweakIt.SavedVariables["WORLD_MAP_ZOOM_FAST_TRAVEL"]
	elseif mapMode == MAP_MODE_KEEP_TRAVEL then
		return TweakIt.SavedVariables["WORLD_MAP_ZOOM_FAST_TRAVEL_KEEP"]
	elseif mapMode == MAP_MODE_AVA_RESPAWN then
		return TweakIt.SavedVariables["WORLD_MAP_ZOOM_AVA_RESPAWN"]
	end
	
    local mapContentType = GetMapContentType()
	if mapContentType == MAP_CONTENT_DUNGEON then
		return TweakIt.SavedVariables["WORLD_MAP_ZOOM_DUNGEON"]
		 
	elseif mapContentType == MAP_CONTENT_AVA then
		return TweakIt.SavedVariables["WORLD_MAP_ZOOM_AVA"]
	end
	
    local mapType = GetMapType()
	if mapType == MAPTYPE_WORLD then
		return TweakIt.SavedVariables["WORLD_MAP_ZOOM_WORLD"]
	elseif mapType == MAPTYPE_ZONE then
		return TweakIt.SavedVariables["WORLD_MAP_ZOOM_ZONE"]
	elseif mapType == MAPTYPE_SUBZONE then
		return TweakIt.SavedVariables["WORLD_MAP_ZOOM_SUBZONE"]
	end
	return TweakIt.SavedVariables["WORLD_MAP_DEFAULT_ZOOM"]
end

local function ChangeZoom(zoomLevel)
	if not ZO_WorldMap_IsWorldMapShowing() then return end
	
	local iDefaultZoom = zoomLevel or GetSettingForMapType()

	local btn = ZO_WorldMapZoomSlider:GetNamedChild("Button"..iDefaultZoom)
	
	zo_callLater(function() ZO_SmoothSliderButton_OnClicked(btn) end, 25)
end

local function ZoomAndPan()
	local iDefaultZoom = GetSettingForMapType()
	local btn = ZO_WorldMapZoomSlider:GetNamedChild("Button"..iDefaultZoom)
	local value = btn.object:GetValueFromButtonIndex(iDefaultZoom)
	
	-- Set new min/max custom zoom levels to the defaultZoom for this mapType
	-- So that when we PanToPlayer, it does not change the zoom level
	--ZO_WorldMap_ClearCustomZoomLevels()
	ZO_WorldMap_SetCustomZoomLevels(value, value)

	ZO_WorldMap_PanToPlayer()
	-- Reset the custom zoom levels:
	TweakIt.InitMaxWorldMapZoom()
	-- Set the slider value so the correct button is highlighted:
	btn.object:SetValue(value)
end
--[[ When the map is originally opened/shown by default it is at zoom level 9 because it calls PanToPlayer. So the player will be in the center of the map (or as close as possible). So when we zoom out & it zooms out on the center of the map, this is the players location so the player stays visible. There is no need to PanToPlayer. Just change the zoom level.
--]]
local function OnMapStateChange(oldState, newState)
	if newState == SCENE_SHOWN or newState == SCENE_SHOWING then
		-- Apparently keep transit shrines don't open at zoom level 9
		--ChangeZoom()
		ZoomAndPan()
	end
end
WORLD_MAP_SCENE:RegisterCallback("StateChange", OnMapStateChange)

--[[
Added the following OnWorldMapChanged because when opening a wayshrine bordering a town the map can sometimes change maps after you open it.
When you navigateIn or Out on the map it starts with a default zoom level of 1
When we change the zoom it automatically zooms on the center of the map & everything is local in code, there is no way to change that, so we must PanToPlayer...but that also zooms in as far as possible, which we don't want it changing our zoom level. So we must set the custom min/max zoom levels to the "wanted" zoom level so that when we panToPlayer the zoom level does not change, then put it back.
--]]
local function OnMapChange(self, wasNavigateIn)
	-- Must delay to give the map, slider, & slider buttons a chance to update
	-- Or the map wont PanToPlayer (and other values will be incorrect)
	
	zo_callLater(function() ZoomAndPan() end, 25)
end
CALLBACK_MANAGER:RegisterCallback("OnWorldMapChanged", OnMapChange)




function TweakIt.HighlightRow(self, hidden)
    if(self) then
        local highlight = self:GetNamedChild("Highlight")
        if(highlight and (highlight:GetType() == CT_TEXTURE)) then
            if not highlight.animation then
                highlight.animation = ANIMATION_MANAGER:CreateTimelineFromVirtual("ShowOnMouseOverLabelAnimation", highlight)
            end
            if hidden then
                highlight.animation:PlayBackward()
            else
                highlight.animation:PlayForward()
            end
        end
    end
end
-- Create Recall Cooldown Window
function TweakIt.InitRecallCooldown()
	local tlw = WINDOW_MANAGER:CreateTopLevelWindow(TweakIt.name.."RecallCooldown")
	tlw:ClearAnchors()
	tlw:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, TweakIt.SavedVariables["WAYPOINT_WINDOW_OFFSETX"], TweakIt.SavedVariables["WAYPOINT_WINDOW_OFFSETY"])
	tlw:SetDimensions(305, 60)
	tlw:SetMouseEnabled(true)
	tlw:SetMovable(true)
	tlw:SetClampedToScreen(true)
	tlw:SetHandler("OnMoveStop", function()
		TweakIt.SavedVariables["WAYPOINT_WINDOW_OFFSETX"] = tlw:GetLeft()
		TweakIt.SavedVariables["WAYPOINT_WINDOW_OFFSETY"] = tlw:GetTop()
	end)
	
	if not TweakIt.SavedVariables["WAYPOINT_WINDOW"] then
		tlw:SetHidden(true)
	end
	
	tlw.bg = WINDOW_MANAGER:CreateControlFromVirtual(TweakIt.name.."RecallCooldownBg", tlw, "ZO_DefaultBackdrop")
	tlw.bg:ClearAnchors()
	tlw.bg:SetAnchorFill()
	
	local cTimeLabel = WINDOW_MANAGER:CreateControl(TweakIt.name.."RecallCooldownTime", tlw, CT_LABEL)
	cTimeLabel:ClearAnchors()
	cTimeLabel:SetAnchor(TOPLEFT, tlw, TOPLEFT, 25, 5)
	cTimeLabel:SetAnchor(BOTTOMRIGHT, tlw, TOPLEFT, 25, 25)
	cTimeLabel:SetFont("ZoFontWinH4")
	cTimeLabel:SetText("Recall Cooldown Time: "..ZO_FormatTimeMilliseconds(GetRecallCooldown(), TIME_FORMAT_STYLE_DESCRIPTIVE, TIME_FORMAT_PRECISION_SECONDS))
	cTimeLabel:SetColor(1,0,0)
	
	-- Reset window size to match text width
	local iTextWidth = cTimeLabel:GetStringWidth(cTimeLabel:GetText())
	tlw:SetDimensions(iTextWidth+50, 60)
	
	local cGoldLabel = WINDOW_MANAGER:CreateControl(TweakIt.name.."RecallCooldownGold", tlw, CT_LABEL)
	cGoldLabel:ClearAnchors()
	cGoldLabel:SetAnchor(TOPLEFT, tlw, TOPLEFT, 25, 30)
	cGoldLabel:SetAnchor(BOTTOMRIGHT, tlw, TOPLEFT, 25, 50)
	cGoldLabel:SetFont("ZoFontWinH4")
	cGoldLabel:SetText(zo_strformat(zo_strformat("Recall Cost ".. "(<<X:1>>|t24:24:EsoUI/Art/currency/currency_gold.dds|t)", ZO_CurrencyControl_FormatCurrency(GetRecallCost()))))
	
	tlw.timeline = ANIMATION_MANAGER:CreateTimeline()
	
	tlw.animation = tlw.timeline:InsertAnimation(ANIMATION_ALPHA, tlw, 5000)
	tlw.animation:SetAlphaValues(1, 0)
	tlw.animation:SetDuration(2500)
	
	tlw.timeline:SetHandler('OnStop',function() 
		tlw:SetHidden(true)
	end)

	tlw.fragment = ZO_HUDFadeSceneFragment:New(tlw)
	tlw.fragment:SetConditional(function() 
		if TweakIt.SavedVariables["RECALL_COOLDOWN_TIMER"] and (GetRecallCooldown() > 0 or TweakIt.SavedVariables["RECALL_COOLDOWN_WINDOW"]) then
			return true
		end
		return false
	end) 
	
	
    HUD_SCENE:AddFragment(tlw.fragment)
    HUD_UI_SCENE:AddFragment(tlw.fragment)
	
end

-- Check the recall cooldown timer
function TweakIt.CheckRecallCooldown()
	if not TweakIt.SavedVariables["RECALL_COOLDOWN_TIMER"] then return end
	if GetRecallCooldown() < 2000 then return end
	
	EVENT_MANAGER:RegisterForUpdate(TweakIt.name.."RecallCooldownTime", 300, function() 
			TweakItRecallCooldownTime:SetText("Recall Cooldown Time: "..ZO_FormatTimeMilliseconds(GetRecallCooldown(), TIME_FORMAT_STYLE_DESCRIPTIVE, TIME_FORMAT_PRECISION_SECONDS))
			
			-- Reset window size to match text width
			local iTextWidth = TweakItRecallCooldownTime:GetStringWidth(TweakItRecallCooldownTime:GetText())
			TweakItRecallCooldown:SetDimensions(iTextWidth+50, 60)
			
			if GetRecallCooldown() == 0 then
				EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."RecallCooldownTime")
				EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."RecallCooldownGold")
				if not TweakIt.SavedVariables["RECALL_COOLDOWN_WINDOW"] then 
					TweakItRecallCooldown.timeline:PlayFromStart()
				end
			end
		end)
	
	EVENT_MANAGER:RegisterForUpdate(TweakIt.name.."RecallCooldownGold", 300, function() 
		TweakItRecallCooldownGold:SetText(zo_strformat("Recall Cost ".. "(<<X:1>>|t24:24:EsoUI/Art/currency/currency_gold.dds|t)", ZO_CurrencyControl_FormatCurrency(GetRecallCost())))
		end)
	TweakItRecallCooldown:SetHidden(false)
	TweakItRecallCooldown:SetAlpha(1)
end

function TweakIt.HideWeaponWin(hide)
	--TweakItCurrentWeapon:SetHidden(hide)
	FRAGMENT_TWEAKIT_WEAPONS:SetHiddenForReason("SettingOff", hide)
end


-- Show Current Weapon
function TweakIt.UpdateCurrentWeapons(_iActiveWeaponPair)
	if not TweakIt.SavedVariables["CURRENT_WEAPON_WINDOW"] or TweakIt.SavedVariablesChar["CURRENT_WEAPON_WINDOW_CHAR_OVERRIDE"] then return end
	
	local iActiveWeaponPair = _iActiveWeaponPair or GetActiveWeaponPairInfo() 
	
	local iconMainHand, isHeldNowMainHand, iconOffHand, isHeldNowOffHand
	
	if iActiveWeaponPair == ACTIVE_WEAPON_PAIR_MAIN then
		local iconMain, slotHasItemMain, _, _, isHeldNowMain = GetEquippedItemInfo(EQUIP_SLOT_MAIN_HAND)
		local iconOff, slotHasItemOff, _, _, isHeldNowOff = GetEquippedItemInfo(EQUIP_SLOT_OFF_HAND)
		if isHeldNowMain 	then iconMainHand = iconMain end
		if isHeldNowOff 	then iconOffHand = iconOff end
		
	elseif iActiveWeaponPair == ACTIVE_WEAPON_PAIR_BACKUP then
		local iconBackupMain, slotHasItemBackupMain, _, _, isHeldNowBackupMain = GetEquippedItemInfo(EQUIP_SLOT_BACKUP_MAIN)
		local iconBackupOff, slotHasItemBackupOff, _, _, isHeldNowBackupOff = GetEquippedItemInfo(EQUIP_SLOT_BACKUP_OFF)
		if isHeldNowBackupMain 	then iconMainHand = iconBackupMain end
		if isHeldNowBackupOff 	then iconOffHand = iconBackupOff end
		
	elseif iActiveWeaponPair == ACTIVE_WEAPON_PAIR_NONE then
		TweakItCurrentWeapon.bgMain:SetHidden(true)
		TweakItCurrentWeapon.bgOff:SetHidden(true)
	end
	
	if iconMainHand then
		TweakItCurrentWeapon.textureMain:SetTexture(iconMainHand)
		TweakItCurrentWeapon.bgMain:SetHidden(false)
	else
		TweakItCurrentWeapon.bgMain:SetHidden(true)
	end
	if iconOffHand then
		TweakItCurrentWeapon.textureOff:SetTexture(iconOffHand)
		TweakItCurrentWeapon.bgOff:SetHidden(false)
	else
		TweakItCurrentWeapon.bgOff:SetHidden(true)
	end
end

local function SetCurrentWeaponSize()
	local tlw = TweakItCurrentWeapon
	local iconSize = TweakIt.SavedVariables["CURRENT_WEAPON_ICON_SIZE"]
	local iconPadding = 5
	
	tlw:SetDimensions(2*iconSize, iconSize+25)
	
	tlw.bgMain:ClearAnchors()
	tlw.bgMain:SetAnchor(TOPLEFT, tlw, TOPLEFT, 0, 0)
	tlw.bgMain:SetAnchor(BOTTOMRIGHT, tlw, TOPLEFT, iconSize, iconSize)
	
	tlw.textureMain:ClearAnchors()
	tlw.textureMain:SetAnchor(TOPLEFT, tlw.bgMain, TOPLEFT, iconPadding, iconPadding)
	tlw.textureMain:SetAnchor(BOTTOMRIGHT, tlw.bgMain, BOTTOMRIGHT, -iconPadding, -iconPadding)
	
	tlw.bgOff:ClearAnchors()
	tlw.bgOff:SetAnchor(TOPLEFT, tlw.bgMain, TOPRIGHT, 0, 0)
	tlw.bgOff:SetAnchor(BOTTOMRIGHT, tlw.bgMain, BOTTOMRIGHT, iconSize, 0)
	
	tlw.textureOff:ClearAnchors()
	tlw.textureOff:SetAnchor(TOPLEFT, tlw.bgOff, TOPLEFT, iconPadding, iconPadding)
	tlw.textureOff:SetAnchor(BOTTOMRIGHT, tlw.bgOff, BOTTOMRIGHT, -iconPadding, -iconPadding)
	
	tlw.label:ClearAnchors()
	tlw.label:SetAnchor(TOPLEFT, tlw.bgMain, BOTTOMLEFT, 0, 0)
	tlw.label:SetAnchor(BOTTOMRIGHT, tlw.bgOff, BOTTOMRIGHT, 0, 20)
end

function TweakIt.InitCurrentWeapon()
	local tlw = WINDOW_MANAGER:CreateTopLevelWindow(TweakIt.name.."CurrentWeapon")
	tlw:ClearAnchors()
	tlw:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, TweakIt.SavedVariables["CURRENT_WEAPON_OFFSETX"], TweakIt.SavedVariables["CURRENT_WEAPON_OFFSETY"])
	tlw:SetDimensions(128, 94)
	tlw:SetMouseEnabled(true)
	tlw:SetMovable(true)
	tlw:SetClampedToScreen(true)
	tlw:SetHandler("OnMoveStop", function()
		TweakIt.SavedVariables["CURRENT_WEAPON_OFFSETX"] = tlw:GetLeft()
		TweakIt.SavedVariables["CURRENT_WEAPON_OFFSETY"] = tlw:GetTop()
	end)
	
	tlw:SetHandler("OnMouseWheel", function(self, delta)
		local iconSize = TweakIt.SavedVariables["CURRENT_WEAPON_ICON_SIZE"]
		if (delta < 0 and iconSize > 32) or (delta > 0 and iconSize < 100) then
			TweakIt.SavedVariables["CURRENT_WEAPON_ICON_SIZE"] = iconSize + delta
		end
		SetCurrentWeaponSize()
	end)
	
	tlw:SetHandler("OnMouseDoubleClick", function(self, button)
			local bShowText = not TweakIt.SavedVariables["CURRENT_WEAPON_HIDE_TEXT"]
			TweakIt.SavedVariables["CURRENT_WEAPON_HIDE_TEXT"] = bShowText
			tlw.label:SetHidden(bShowText)
	end)
	
	
	tlw.bgMain = WINDOW_MANAGER:CreateControlFromVirtual(TweakIt.name.."CurrentWeaponBgMain", tlw, "ZO_DefaultBackdrop")
	
	tlw.textureMain = WINDOW_MANAGER:CreateControl(TweakIt.name.."CurrentWeaponTextureMain", tlw.bgMain, CT_TEXTURE)
	
	tlw.bgOff = WINDOW_MANAGER:CreateControlFromVirtual(TweakIt.name.."CurrentWeaponBgOff", tlw, "ZO_DefaultBackdrop")
	
	tlw.textureOff = WINDOW_MANAGER:CreateControl(TweakIt.name.."CurrentWeaponTextureOff", tlw.bgOff, CT_TEXTURE)
	
	tlw.label = WINDOW_MANAGER:CreateControl(TweakIt.name.."CurrentWeaponLabel", tlw, CT_LABEL)
	tlw.label:SetFont("ZoFontWinH4")
	tlw.label:SetText("Current Weapon")
	tlw.label:SetColor(1,0,0)
	tlw.label:SetHorizontalAlignment(TEXT_ALIGN_CENTER)
	tlw.label:SetHidden(TweakIt.SavedVariables["CURRENT_WEAPON_HIDE_TEXT"])
	
	FRAGMENT_TWEAKIT_WEAPONS = ZO_HUDFadeSceneFragment:New(tlw) 
	HUD_SCENE:AddFragment(FRAGMENT_TWEAKIT_WEAPONS)
	HUD_UI_SCENE:AddFragment(FRAGMENT_TWEAKIT_WEAPONS)
	
	if not TweakIt.SavedVariables["CURRENT_WEAPON_WINDOW"] or TweakIt.SavedVariablesChar["CURRENT_WEAPON_WINDOW_CHAR_OVERRIDE"] then 
		TweakItCurrentWeapon:SetHidden(true)
		TweakIt.HideWeaponWin(true)
	end
	
	SetCurrentWeaponSize()
	TweakIt.UpdateCurrentWeapons()
end


function TweakIt.InitKillWindow()
	local tlw = WINDOW_MANAGER:CreateTopLevelWindow(TweakIt.name.."KillWindow")
	tlw:ClearAnchors()
	tlw:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, TweakIt.SavedVariables["CURRENT_KILL_WINDOW_OFFSETX"], TweakIt.SavedVariables["CURRENT_KILL_WINDOW_OFFSETY"])
	--tlw:SetDimensions(128, 94)
	tlw:SetMouseEnabled(true)
	tlw:SetMovable(true)
	tlw:SetClampedToScreen(true)
	tlw:SetAlpha(0)
	tlw:SetHidden(true)
	tlw:SetHandler("OnMoveStop", function()
		TweakIt.SavedVariables["CURRENT_KILL_WINDOW_OFFSETX"] = tlw:GetLeft()
		TweakIt.SavedVariables["CURRENT_KILL_WINDOW_OFFSETY"] = tlw:GetTop()
	end)
	
	tlw.label = WINDOW_MANAGER:CreateControl(TweakIt.name.."KillWindowLabel", tlw, CT_LABEL)
	tlw.label:ClearAnchors()
	tlw.label:SetAnchorFill()
	tlw.label:SetFont("ZoFontWinH4")
	tlw.label:SetText("Kill Window Label")
	tlw.label:SetHorizontalAlignment(TEXT_ALIGN_CENTER)
	tlw.label:SetVerticalAlignment(TEXT_ALIGN_CENTER)
	tlw.label:SetColor(1,0,0)
	
	-- Reset window size to match text width
	local iTextWidth = tlw.label:GetStringWidth(tlw.label:GetText())
	tlw:SetDimensions(iTextWidth+20, 40)
	
	tlw.timeline = ANIMATION_MANAGER:CreateTimeline()
	
	tlw.animation = tlw.timeline:InsertAnimation(ANIMATION_ALPHA, tlw, 5000)
	tlw.animation:SetAlphaValues(1, 0)
	tlw.animation:SetDuration(2500)
	tlw.timeline:SetHandler('OnStop',function() 
		tlw:SetHidden(true)
	end)
end



-- Set Boosters for 100% success Chance
local OrigSetImprovementSlotItem = ZO_SharedSmithingImprovement.SetImprovementSlotItem
function ZO_SharedSmithingImprovement:SetImprovementSlotItem(bagId, slotIndex)
	OrigSetImprovementSlotItem(self, bagId, slotIndex)
	
	if TweakIt.SavedVariables["IMPROVE_AUTO_MAX_BOOSTERS"] then 
		local iMaxBoosters = SMITHING.improvementPanel:FindMaxBoostersToApply()
		SMITHING.improvementPanel.spinner:SetValue(iMaxBoosters)
	end
end


--function ZO_SharedSmithingImprovement:SharedImprove(dialogName)
local function OnSharedImprove(self, dialogName)
    local itemToImproveBagId, itemToImproveSlotIndex, craftingType = self:GetCurrentImprovementParams()
    local numBoostersToApply = self:GetNumBoostersToApply()

    local chance = GetSmithingImprovementChance(itemToImproveBagId, itemToImproveSlotIndex, numBoostersToApply, craftingType)
	
	if TweakIt.SavedVariables["IMPROVE_100SUCCESS_SKIP_DIALOG"] and chance == 100 then 
		ImproveSmithingItem(itemToImproveBagId, itemToImproveSlotIndex, numBoostersToApply)
	end
	return false
end
ZO_PreHook(ZO_SharedSmithingImprovement, "SharedImprove", OnSharedImprove)


function TweakIt.GetQuedCampaignInfo()
	local iCampaignEntries = GetNumCampaignQueueEntries() 
	
	for entryIndex = 1, iCampaignEntries do
		local iCampaignId, bQueueAsGroup = GetCampaignQueueEntry(entryIndex) 
		if IsQueuedForCampaign(iCampaignId, bQueueAsGroup)  or IsQueuedForCampaign(iCampaignId, bQueueAsGroup) then
			return iCampaignId, bQueueAsGroup
		end
	end
end
	
-- Moved out as separate function so it can also be used in the registered update 
-- for auto-joining campaign
local function JoinCampaign()
	local iCampaignId, bQueueAsGroup = TweakIt.GetQuedCampaignInfo()
	EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."CampaignTime")
	ConfirmCampaignEntry(iCampaignId, bQueueAsGroup, true) 
end
	
function TweakIt.InitCampaignQueWindow()
	local iTextHorPadding 	= 20
	local iTextVertPadding 	= 10
	local iLineHeight		= 20

	local tlw = WINDOW_MANAGER:CreateTopLevelWindow(TweakIt.name.."CampaignQue")
	tlw:ClearAnchors()
	tlw:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, TweakIt.SavedVariables["CAMPAIGN_QUE_OFFSETX"], TweakIt.SavedVariables["CAMPAIGN_QUE_OFFSETY"])
	tlw:SetDimensions(300, 50)
	tlw:SetMouseEnabled(true)
	tlw:SetMovable(true)
	tlw:SetClampedToScreen(true)
	
	tlw:SetHandler("OnMoveStop", function()
		TweakIt.SavedVariables["CAMPAIGN_QUE_OFFSETX"] = tlw:GetLeft()
		TweakIt.SavedVariables["CAMPAIGN_QUE_OFFSETY"] = tlw:GetTop()
	end)
	
	tlw.bg = WINDOW_MANAGER:CreateControlFromVirtual(TweakIt.name.."CampaignQueBg", tlw, "ZO_DefaultBackdrop")
	tlw.bg:ClearAnchors()
	tlw.bg:SetAnchorFill()
	
	local iCampaignId, bQueueAsGroup = TweakIt.GetQuedCampaignInfo()
	local iPositionQue 		= GetCampaignQueuePosition(iCampaignId, bQueueAsGroup) 
	local iCampaignState 	= GetCampaignQueueState(iCampaignId, bQueueAsGroup) 
	
	if not TweakIt.SavedVariables["CAMPAIGN_QUE_WINDOW"] or not iCampaignId then
		tlw:SetHidden(true)
	end
	
	tlw.labelState = WINDOW_MANAGER:CreateControl(TweakIt.name.."CampaignQueStateLabel", tlw, CT_LABEL)
	tlw.labelState:ClearAnchors()
	tlw.labelState:SetAnchor(TOPLEFT, tlw, TOPLEFT, iTextHorPadding, iTextVertPadding)
	tlw.labelState:SetAnchor(BOTTOMRIGHT, tlw, TOPRIGHT, -iTextHorPadding, iTextVertPadding+iLineHeight)
	tlw.labelState:SetFont("ZoFontWinH4")
	tlw.labelState:SetText("Campaign State: "..tCampaignStates[iCampaignState])
	tlw.labelState:SetColor(1,0,0)
	
	tlw.labelGroup = WINDOW_MANAGER:CreateControl(TweakIt.name.."CampaignQueGroupLabel", tlw, CT_LABEL)
	tlw.labelGroup:ClearAnchors()
	tlw.labelGroup:SetAnchor(TOPLEFT, tlw, TOPLEFT, iTextHorPadding, (2*iTextVertPadding)+iLineHeight)
	tlw.labelGroup:SetAnchor(BOTTOMRIGHT, tlw, TOPRIGHT, -iTextHorPadding, (2*iTextVertPadding)+(2*iLineHeight))
	tlw.labelGroup:SetFont("ZoFontWinH4")
	tlw.labelGroup:SetText("Qued As A Group: "..tostring(bQueueAsGroup))
	tlw.labelGroup:SetColor(1,0,0)
	
	tlw.labelPosition = WINDOW_MANAGER:CreateControl(TweakIt.name.."CampaignQuePositionLabel", tlw, CT_LABEL)
	tlw.labelPosition:ClearAnchors()
	tlw.labelPosition:SetAnchor(TOPLEFT, tlw, TOPLEFT, iTextHorPadding, (3*iTextVertPadding)+(2*iLineHeight))
	tlw.labelPosition:SetAnchor(BOTTOMRIGHT, tlw, TOPRIGHT, -iTextHorPadding, (3*iTextVertPadding)+(3*iLineHeight))
	tlw.labelPosition:SetFont("ZoFontWinH4")
	tlw.labelPosition:SetText("Position In Que: ".. iPositionQue)
	tlw.labelPosition:SetColor(1,0,0)
	
	tlw.labelTime = WINDOW_MANAGER:CreateControl(TweakIt.name.."CampaignQueTimeLabel", tlw, CT_LABEL)
	tlw.labelTime:ClearAnchors()
	tlw.labelTime:SetAnchor(TOPLEFT, tlw, TOPLEFT, iTextHorPadding, (4*iTextVertPadding)+(3*iLineHeight))
	tlw.labelTime:SetAnchor(BOTTOMRIGHT, tlw, BOTTOMRIGHT, -iTextVertPadding, 0)
	tlw.labelTime:SetFont("ZoFontWinH4")
	tlw.labelTime:SetText("Time In Que: ")
	tlw.labelTime:SetColor(1,0,0)
	
	tlw.BtnAccept = WINDOW_MANAGER:CreateControlFromVirtual(TweakIt.name.."CampaignQueAccept", tlw,  "ZO_BladeHeader")
	tlw.BtnAccept:ClearAnchors()
	tlw.BtnAccept:SetAnchor(TOPLEFT, tlw, BOTTOMLEFT, 0, 0)
	tlw.BtnAccept:SetAnchor(BOTTOMRIGHT, tlw, BOTTOMLEFT, tlw:GetWidth()/2, 30)
	tlw.BtnAccept:SetText("Join")
	tlw.BtnAccept:SetHandler("OnClicked", JoinCampaign)
	tlw.BtnAccept:SetClickSound("Click")
	tlw.BtnAccept:SetEnabled(false)
	
	local function LeaveQue()
		local iCampaignId, bQueueAsGroup = TweakIt.GetQuedCampaignInfo()
		EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."CampaignTime")
		LeaveCampaignQueue(iCampaignId, bQueueAsGroup) 
	end
	
	tlw.BtnLeave = WINDOW_MANAGER:CreateControlFromVirtual(TweakIt.name.."CampaignQueLeave", tlw,  "ZO_BladeHeader")
	tlw.BtnLeave:ClearAnchors()
	tlw.BtnLeave:SetAnchor(TOPLEFT, tlw, BOTTOMLEFT, tlw:GetWidth()/2, 0)
	tlw.BtnLeave:SetAnchor(BOTTOMRIGHT, tlw, BOTTOMRIGHT, 0, 30)
	tlw.BtnLeave:SetText("Leave Que")
	tlw.BtnLeave:SetHandler("OnClicked", LeaveQue)
	tlw.BtnLeave:SetClickSound("Click")
	tlw.BtnLeave:SetEnabled(false)
	
	tlw.timeline = ANIMATION_MANAGER:CreateTimeline()
	tlw.animation = tlw.timeline:InsertAnimation(ANIMATION_ALPHA, tlw, 5000)
	tlw.animation:SetAlphaValues(1, 0)
	tlw.animation:SetDuration(2500)
	
	tlw.timeline:SetHandler('OnStop',function() 
		tlw:SetHidden(true)
	end)
	
	TweakIt.UpdateCampaignWindow()
end

local function UpdateCampaignWindowSize()
	local iTextHorPadding 	= 20
	local iTextVertPadding 	= 10
	local iLineHeight		= 20
	
	local tlw = TweakItCampaignQue
	local iStateTextWidth 		= tlw.labelState:GetStringWidth(tlw.labelState:GetText())
	local iGroupTextWidth 		= tlw.labelGroup:GetStringWidth(tlw.labelGroup:GetText())
	local iPositionTextWidth 	= tlw.labelPosition:GetStringWidth(tlw.labelPosition:GetText())
	local iTimeTextWidth 		= tlw.labelTime:GetStringWidth(tlw.labelTime:GetText())
	local iMaxWidth = math.max(iStateTextWidth, iGroupTextWidth, iPositionTextWidth, iTimeTextWidth)
	
	tlw:SetDimensions(iMaxWidth+(2*iTextHorPadding), (5*iTextVertPadding)+(4*iLineHeight))
end

function TweakIt.UpdateCampaignWindow(_iCampaignId, _bQuedAsGroup, _iState, _iPosition)
	local iCampaignId, bQueueAsGroup
	if not _iCampaignId or _bQuedAsGroup == nil then
		iCampaignId, bQueueAsGroup = TweakIt.GetQuedCampaignInfo()
	else
		iCampaignId = _iCampaignId
		bQueueAsGroup = _bQuedAsGroup
	end
	
	if not TweakIt.SavedVariables["CAMPAIGN_QUE_WINDOW"] or not iCampaignId then
		TweakItCampaignQue:SetHidden(true)
	else
		TweakItCampaignQue:SetHidden(false)
	end
	
	local iCampaignState 	= _iState or GetCampaignQueueState(iCampaignId, bQueueAsGroup) 
	local iPositionQue 		= _iPosition or GetCampaignQueuePosition(iCampaignId, bQueueAsGroup) 
	
	TweakItCampaignQue.labelState:SetText("Campaign State: ".. tCampaignStates[iCampaignState])
	TweakItCampaignQue.labelGroup:SetText("Qued As A Group: "..tostring(bQueueAsGroup))
	TweakItCampaignQue.labelPosition:SetText("Position In Que: ".. iPositionQue)
	
	
	EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."CampaignTime")
		
	if iCampaignState == CAMPAIGN_QUEUE_REQUEST_STATE_WAITING then 
		TweakItCampaignQue.BtnLeave:SetEnabled(true)
		TweakItCampaignQue.BtnAccept:SetEnabled(false)
		local iTime = GetSecondsInCampaignQueue(iCampaignId, bQueueAsGroup)
		TweakItCampaignQue.labelTime:SetText("Time In Que: ".. FormatTimeSeconds(iTime, TIME_FORMAT_STYLE_DESCRIPTIVE, TIME_FORMAT_PRECISION_SECONDS))
		
		EVENT_MANAGER:RegisterForUpdate(TweakIt.name.."CampaignTime", 300, function() 
			local iTime = GetSecondsInCampaignQueue(iCampaignId, bQueueAsGroup)
			TweakItCampaignQue.labelTime:SetText("Time In Que: ".. FormatTimeSeconds(iTime, TIME_FORMAT_STYLE_DESCRIPTIVE, TIME_FORMAT_PRECISION_SECONDS))
			UpdateCampaignWindowSize()
		end)
		
	elseif iCampaignState == CAMPAIGN_QUEUE_REQUEST_STATE_CONFIRMING then   
		TweakItCampaignQue.BtnLeave:SetEnabled(true) 
		TweakItCampaignQue.BtnAccept:SetEnabled(true)
		local iTime = GetCampaignQueueRemainingConfirmationSeconds(iCampaignId, bQueueAsGroup) 
		TweakItCampaignQue.labelTime:SetText("Confirmation Time Remaining: ".. FormatTimeSeconds(iTime, TIME_FORMAT_STYLE_DESCRIPTIVE, TIME_FORMAT_PRECISION_SECONDS))
		local bWarningGiven = false
		
		local function PlayAnnouncement()
			CENTER_SCREEN_ANNOUNCE:AddMessage(EVENT_ACHIEVEMENT_AWARDED, CSA_EVENT_LARGE_TEXT, SOUNDS.ACHIEVEMENT_AWARDED, colorDrkOrange.."Campaign Ready")
		end
		
		EVENT_MANAGER:RegisterForUpdate(TweakIt.name.."CampaignTime", 300, function() 
			local iTime = GetCampaignQueueRemainingConfirmationSeconds(iCampaignId, bQueueAsGroup)
			local iTimeInSecs = FormatTimeSeconds(iTime, TIME_FORMAT_STYLE_DESCRIPTIVE, TIME_FORMAT_PRECISION_SECONDS)
			TweakItCampaignQue.labelTime:SetText("Confirmation Time Remaining: "..iTimeInSecs)
			UpdateCampaignWindowSize()
			
			if iTime < 20 and bWarningGiven == false then 
				--enable game sounds if game doesn't have focus
				if not (DoesGameHaveFocus() or GetSetting_Bool(SETTING_TYPE_AUDIO, AUDIO_SETTING_BACKGROUND_AUDIO)) then
					--SetSetting(integer system, integer settingId, string value, integer setOptions) 
					SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_BACKGROUND_AUDIO, "true")
					PlayAnnouncement()
					EVENT_MANAGER:RegisterForEvent(TweakIt.name, EVENT_GAME_FOCUS_CHANGED, function(evt, hasFocus)
						   if hasFocus then
							   EVENT_MANAGER:UnregisterForEvent(TweakIt.name, EVENT_GAME_FOCUS_CHANGED)
							   SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_BACKGROUND_AUDIO, "false")
						   end
					end)
				end
				bWarningGiven = true
			end
			if TweakIt.SavedVariables["CAMPAIGN_QUE_AUTOJOIN"] and iTime < TweakIt.SavedVariables["CAMPAIGN_QUE_AUTOJOIN_TIME"] then
				JoinCampaign()
			end
		end)
		
	else
		TweakItCampaignQue.BtnLeave:SetEnabled(false)
		TweakItCampaignQue.BtnAccept:SetEnabled(false)
		TweakItCampaignQue.labelTime:SetText("Time Remaining: Not In Que")
		--EVENT_MANAGER:UnregisterForUpdate(TweakIt.name.."CampaignTime")
	end
	
	UpdateCampaignWindowSize()
end









